/***************************************************************************
 *   Copyright (C) 2004 by Rick L. Vinyard, Jr.                            *
 *   rvinyard@cs.nmsu.edu                                                  *
 *                                                                         *
 *   This file is part of the conexus library.                             *
 *                                                                         *
 *   The conexus library is free software; you can redistribute it and/or  *
 *   modify it under the terms of the GNU General Public License           *
 *   version 3 as published by the Free Software Foundation.               *
 *                                                                         *
 *   The conexus library is distributed in the hope that it will be        *
 *   useful, but WITHOUT ANY WARRANTY; without even the implied warranty   *
 *   of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU   *
 *   General Public License for more details.                              *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this software. If not see <http://www.gnu.org/licenses/>.  *
 ***************************************************************************/
#include <conexus/conexus-config.h>

#ifndef CONEXUSPOINTER
#define CONEXUSPOINTER
  // Headers for smart pointers
#ifdef CONEXUS_USE_BOOST_SMART_POINTER
    #include <boost/shared_ptr.hpp>
    #include <boost/weak_ptr.hpp>
    #define ConexusPointer boost::shared_ptr
    #define ConexusWeakPointer boost::weak_ptr
    #define conexus_static_pointer_cast  boost::static_pointer_cast
    #define conexus_const_pointer_cast   boost::const_pointer_cast
    #define conexus_dynamic_pointer_cast boost::dynamic_pointer_cast
  #else
    #ifdef CONEXUS_USE_CXX0X_SMART_POINTER
      #include <memory>
      #define ConexusPointer std::shared_ptr
      #define ConexusWeakPointer std::weak_ptr
      #define conexus_static_pointer_cast  std::static_pointer_cast
      #define conexus_const_pointer_cast   std::const_pointer_cast
      #define conexus_dynamic_pointer_cast std::dynamic_pointer_cast
    #else
      #include <typeinfo>
      #include <memory>
      #include <functional>
      #include <bits/concurrence.h>
      #include <ext/mt_allocator.h>
      #include <tr1/boost_shared_ptr.h>
      #define ConexusPointer std::tr1::shared_ptr
      #define ConexusWeakPointer std::tr1::weak_ptr
      #define conexus_static_pointer_cast  std::tr1::static_pointer_cast
      #define conexus_const_pointer_cast   std::tr1::const_pointer_cast
      #define conexus_dynamic_pointer_cast std::tr1::dynamic_pointer_cast
    #endif
  #endif

#endif
